/**
 * 
 */
package sim.graphics.light;

import sim.graphics.SColor;
import sim.readwrite.SWriteable;


/**
 * L'interface <b>SLight</b> reprsentant une source de lumire.
 * 
 * @author Simon Vzina
 * @since 2015-01-09
 * @version 2016-02-17
 */
public interface SLight extends SWriteable {

  /**
   * Mthode pour obtenir le numro correspondant au nom de la source de lumire.
   * 
   * @return Le numro correspondant au nom de la gomtrie.
   */
  public int getCodeName();
  
  /**
	 * Mthode pour obtenir la couleur de la source de lumire.
	 * 
	 * @return La couleur de la source de lumire.
	 */
	public SColor getColor();
		
}//fin interface SLight
