/**
 * 
 */
package sim.graphics.material;

import sim.exception.SRuntimeException;

/**
 * L'interface STextureMaterial correspond  un matriel contenant des textures.
 * @author Simon Vzina
 * @since 2015-10-31
 * @version 2015-12-08
 */
public interface STextureMaterial extends SMaterial {

  /**
   * Mthode permettant de modifier le format d'interprtation des coordonnes uv de texture.
   * @param uv_format - Le code d'interprtation des coordonne uv.
   * @throws SRuntimeException Si le code d'interprtation des coordonnes uv n'est pas reconnu par le systme.
   * @throws SRuntimeException Si la dfinition a dj t ralis une fois. Une texture ne peut pas se faire modifier son code d'interprtation plus d'une fois.
   */
  public void setUVFormat(int uv_format) throws SRuntimeException;
  
  /**
   * Mthode dterminant si le code d'interprtation des coordonnes uv de texture a t dfini pour cette texture.
   * @return <b>true</b> si le code a t dfini et <b>false</b> sinon.
   */
  public boolean isUVFormatSelected();
  
}//fin de l'interface STextureMaterial
