/**
 * 
 */
package sim.parser.model.agp;

/**
 * Classe reprsentant un point 3d d'un modle 3d de format "agp" (modle 3d du <i>projet Anaglyphe</i> ralis par Anik Soulire).
 * 
 * @author Simon Vzina
 * @since 2015-08-01
 * @version 2015-08-01
 */
public class SPoint {

  //Les coordonnes par dfaut
  private static final double DEFAULT_X = 0.0;
  private static final double DEFAULT_Y = 0.0;
  private static final double DEFAULT_Z = 0.0;
  
  //Les trois coordonnes du point 3d
  private double x;
  private double y;
  private double z;
  
  /**
   *  Constructeur d'une point par dfaut. 
   */
  public SPoint()
  {
    x = DEFAULT_X;
    y = DEFAULT_Y;
    z = DEFAULT_Z;
  }

  /**
   * Mthode pour obtenir la coordonne <i>x</i> du point.
   * @return la coordonne <i>x</i>.
   */
  public double getX()
  {
    return x;
  }

  /**
   * Mthode pour obtenir la coordonne <i>y</i> du point.
   * @return la coordonne <i>y</i>.
   */
  public double getY()
  {
    return y;
  }

  /**
   * Mthode pour obtenir la coordonne <i>z</i> du point.
   * @return la coordonne <i>z</i>.
   */
  public double getZ()
  {
    return z;
  }

  /**
   * Mthode pour dfinir la coordonne <i>x</i> du point.
   * @param x - La nouvelle coordonne <i>x</i> du point.
   */
  public void setX(double x)
  {
    this.x = x;
  }

  /**
   * Mthode pour dfinir la coordonne <i>y</i> du point.
   * @param y - La nouvelle coordonne <i>y</i> du point.
   */
  public void setY(double y)
  {
    this.y = y;
  }

  /**
   * Mthode pour dfinir la coordonne <i>z</i> du point.
   * @param z - La nouvelle coordonne <i>z</i> du point.
   */
  public void setZ(double z)
  {
    this.z = z;
  }

  /* (non-Javadoc)
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString()
  {
    return "SPoint [x=" + x + ", y=" + y + ", z=" + z + "]";
  }
  
}//fin de la classe SPoint
