/**
 * 
 */
package sim.physics;

import sim.exception.SNoImplementationException;
import sim.math.SVector3d;

/**
 * La classe <b>SGeometricalOptics</b> reprsente une classe utilisaire pouvante effectuer des calculs en lien avec la <b>l'optique gomtrique</b>.
 * 
 * @author Simon Vzina
 * @since 2015-01-16
 * @version 2020-02-10 (version labo 2.109 : Le ray tracer)
 */
public class SGeometricalOptics {

	/**
	 * Mthode qui value la <b>rflexion</b> d'un rayon <b><i>v</i></b> sur une normale  la surface <b><i>N</i></b>.
	 * La solution  la rflexion est un rayon rflchi <b><i>R</i></b>. Ce calcul respecte la <u>loi de la rflexion</u>.
	 * 
	 * @param v Le rayon <b><i>v</i></b> incident.  
	 * @param N La normale  la surface <b><i>N</i></b>.
	 * @return Le rayon rflchi <b><i>R</i></b>.
	 */
	public static SVector3d reflexion(SVector3d v, SVector3d N)
	{
		throw new SNoImplementationException("Cette mthode doit tre implmente dans le cadre d'un laboratoire.");
	}
	
	/**
	 * Mthode qui value la <b>rfraction</b> d'un rayon <b><i>v</i></b> par rapport  une normale  la surface <b><i>N</i></b>.
	 * La solution  la rfraction est un rayon transmis <b><i>T</i></b>. Ce calcul respecte la <u>loi de la rfraction</u>.
	 * 
	 * @param v Le rayon <b><i>v</i></b> incident.  
	 * @param N La normale  la surface <b><i>N</i></b>.
	 * @param n1 L'indice de rfraction du milieu incident.
	 * @param n2 L'indice de rfraction du milieu rfract.
	 * @return Le rayon transmis <b><i>T</i></b>.
	 * @throws STotalInternalReflectionException S'il y a rflexion totale interne ce qui interdit la transmission d'un rayon selon la loi de la rfraction.
	 */
	public static SVector3d refraction(SVector3d v, SVector3d N, double n1, double n2) throws STotalInternalReflectionException
	{
	  throw new SNoImplementationException("Cette mthode doit tre implmente dans le cadre d'un laboratoire.");
	}
	
	/**
	 * <p>
	 * Mthode qui dtermine s'il y aura rflexion totale interne. 
	 * </p>
	 * <p>
	 * Une rflexion totale interne est <u>uniquement possible</u> si n1 > n2. 
	 * </p>
	 * 
	 * @param v Le rayon <b><i>v</i></b> incident.  
	 * @param N La normale  la surface <b><i>N</i></b>.
	 * @param n1 L'indice de rfraction du milieu incident.
	 * @param n2 L'indice de rfraction du milieu rfract.
	 * @return <b>true</b> s'il y a rflexion totale interne et <b>false</b> sinon.
	 */
	public static boolean isTotalInternalReflection(SVector3d v, SVector3d N, double n1, double n2)
	{
	  throw new SNoImplementationException("Cette mthode doit tre implmente dans le cadre d'un laboratoire.");
	}

}//fin classe SGeometricalOptics
